var express = require('express');
var mongoose = require('mongoose');
var mustacheExpress = require('mustache-express');
var app = express();

var Joke = require('./model/joke');

app.set('views', './views/');
app.set('view engine', 'mustache');
app.engine('mustache', mustacheExpress());
app.use(express.urlencoded());

mongoose.connect('mongodb://testuser:testpwd@mongodb.drlue.at:9000/testdb?ssl=true&authMechism=DEFAULT&authSource=authdb')
var db = mongoose.connection;
db.on('error', console.error.bind(console, "MongoDB connection error:"));
db.once('open', () => {
  console.log("Connected...");
})

//Jokes zurückgeben
app.get('/', function (req, res) {
  Joke.find({})
    .then((jokes) => {
      if (req.accepts('Text/html')) {
        res.render('joke', { jokes: jokes });
      } else {
        res.json(jokes);
      }
    })
    .catch((error) => {
      res.send("FEHLER");
    })
});

//Formular fürs Joke erstellen
app.get('/create', function (req, res) {
  res.render("createjoke");
})

//Joke löschen mittels http get
app.get('/:id/delete', function (req, res) {
  Joke.findOneAndDelete({ _id: req.params.id })
    .then((result) => {
      console.log("Successfully deleted...");
      res.redirect('/');
    })
    .catch((error) => {
      console.log("Failed to delete...");
      res.redirect('/');
    })
});

//Joke editieren
app.get('/:id/edit', function (req, res) {
  Joke.findById({ _id: req.params.id })
    .then((result) => {
      res.render('editjoke', result);
    })
    .catch((error) => {
      console.log("Failed to edit...");
      res.redirect('/');
    })
});

//Delete joke
app.delete('/:id', function (req, res) {
  Joke.findOneAndDelete({ _id: req.params.id })
    .then((result) => {
      if (result == null) {
        //Joke wurde nicht gefunden
        res.sendStatus(404);
      } else {
        //Joke wurde erfolgreich gelöscht
        res.sendStatus(200);
		console.log("Successfully deleted...");
      }
    })
    .catch((error) => {
      console.log("Failed to delete...");
      res.sendStatus(500);
    })
});

//Create new joke
app.post('/', function (req, res) {
  Joke.create({ author: req.body.name, text: req.body.witz })
    .then((result) => {
      if (req.accepts('text/html')) {
        res.redirect('/');
      }
      else {
        res.json(result);
      }
    })
    .catch((error) => {
      if (req.accepts('text/html')) {
        res.redirect('/');
      }
      else {
        res.json({ error: "could not create joke" });
      }
    });
});

//Update joke
app.post('/:id', function (req, res) {
  Joke.findByIdAndUpdate(req.params.id, { author: req.body.author, text: req.body.text })
    .then((result) => {
      if (req.accepts('text/html')) {
        res.redirect('/');
      }
      else {
        res.json(result);
      }
    })
    .catch((error) => {
      if (req.accepts('text/html')) {
        res.redirect('/');
      }
      else {
        res.json({ error: "could not create joke" });
      }
    });
});

app.listen(3000, function () {
  console.log('Example app listening on port 3000!');
});
